#!/bin/sh
#
# check_metastat - Nagios plugin, runs Solaris metastat
# by Michael Tosch
#

set -f
PATH=/bin:/usr/bin:/usr/sbin:/sbin:/opt/SUNWmd/sbin
export PATH

lines=`{ metastat | grep 'State:'; } 2>/dev/null`
errstate=$?
if [ -z "$lines" ]
then
    echo 'No metadevices on this system!'
    exit 3
fi

lines=`echo "$lines" | grep -vc 'Okay'`
if [ $lines -eq 0 -a $errstate -eq 0 ]
then
    echo "OK - All metadevices are stable"
    exit 0
else
    echo "CRITICAL - Metadevices NOT ok ($errstate)"
    exit 2
fi
exit 1
